%global namedreltag .RELEASE
%global namedversion %{version}%{?namedreltag}
%global oname spring-integration

Name:          springframework-integration
# Newer release require springframework >= 4.1.7.RELEASE
Version:       3.0.7
Release:       3%{?dist}
Summary:       Extends the Spring Enterprise Integration Patterns Support
License:       ASL 2.0
URL:           http://projects.spring.io/spring-integration/
Source0:       https://github.com/spring-projects/spring-integration/archive/v%{namedversion}.tar.gz
# sh spring-integration-get-poms.sh <NAMED VERSION>
Source1:       spring-integration-poms-%{namedversion}.tar.xz 
Source2:       spring-integration-get-poms.sh

Patch0:        springframework-integration-3.0.7-spring-retry1.1.patch
Patch1:        springframework-integration-3.0.7-smack4.patch

BuildRequires: maven-local
BuildRequires: mvn(com.fasterxml.jackson.core:jackson-databind)
BuildRequires: mvn(com.google.guava:guava)
BuildRequires: mvn(com.h2database:h2)
BuildRequires: mvn(com.jayway.jsonpath:json-path)
BuildRequires: mvn(com.jcraft:jsch)
BuildRequires: mvn(com.lambdaworks:lettuce)
BuildRequires: mvn(com.sun.xml.messaging.saaj:saaj-impl)
BuildRequires: mvn(commons-io:commons-io)
BuildRequires: mvn(commons-net:commons-net)
BuildRequires: mvn(javax.mail:mail)
BuildRequires: mvn(javax.xml.soap:saaj-api)
BuildRequires: mvn(junit:junit)
BuildRequires: mvn(log4j:log4j:1.2.17)
BuildRequires: mvn(org.apache.activemq:activemq-core)
BuildRequires: mvn(org.apache.geronimo.specs:geronimo-jms_1.1_spec)
BuildRequires: mvn(org.apache.geronimo.specs:specs:pom:)
BuildRequires: mvn(org.apache.openjpa:openjpa-jdbc)
BuildRequires: mvn(org.apache.sshd:sshd-core)
BuildRequires: mvn(org.aspectj:aspectjweaver)
BuildRequires: mvn(org.codehaus.groovy:groovy-all)
BuildRequires: mvn(org.codehaus.jackson:jackson-mapper-asl)
BuildRequires: mvn(org.easymock:easymock)
BuildRequires: mvn(org.hamcrest:hamcrest-all)
BuildRequires: mvn(org.hibernate.javax.persistence:hibernate-jpa-2.0-api)
BuildRequires: mvn(org.igniterealtime.smack:smack-core)
BuildRequires: mvn(org.igniterealtime.smack:smack-extensions)
BuildRequires: mvn(org.igniterealtime.smack:smack-resolver-javax)
BuildRequires: mvn(org.igniterealtime.smack:smack-tcp)
BuildRequires: mvn(org.mockito:mockito-core)
BuildRequires: mvn(org.powermock:powermock-api-mockito)
BuildRequires: mvn(org.powermock:powermock-module-junit4)
BuildRequires: mvn(org.python:jython-standalone)
BuildRequires: mvn(org.springframework:spring-aop)
BuildRequires: mvn(org.springframework:spring-context)
BuildRequires: mvn(org.springframework:spring-context-support)
BuildRequires: mvn(org.springframework:spring-expression)
BuildRequires: mvn(org.springframework:spring-jdbc)
BuildRequires: mvn(org.springframework:spring-jms)
BuildRequires: mvn(org.springframework:spring-orm)
BuildRequires: mvn(org.springframework:spring-oxm)
BuildRequires: mvn(org.springframework:spring-test)
BuildRequires: mvn(org.springframework:spring-tx)
BuildRequires: mvn(org.springframework:spring-web)
BuildRequires: mvn(org.springframework:spring-webmvc)
BuildRequires: mvn(org.springframework.amqp:spring-rabbit)
BuildRequires: mvn(org.springframework.data:spring-data-mongodb)
BuildRequires: mvn(org.springframework.data:spring-data-redis)
BuildRequires: mvn(org.springframework.retry:spring-retry)
BuildRequires: mvn(org.springframework.security:spring-security-config)
BuildRequires: mvn(org.springframework.security:spring-security-core)
BuildRequires: mvn(org.springframework.social:spring-social-twitter)
BuildRequires: mvn(org.springframework.ws:spring-ws-core)
BuildRequires: mvn(org.springframework.ws:spring-ws-support)
BuildRequires: mvn(org.springframework.ws:spring-xml)
BuildRequires: mvn(xmlunit:xmlunit)

BuildArch:     noarch

%description
Extends the Spring programming model to support the
well-known Enterprise Integration Patterns. Spring
Integration enables lightweight messaging within
Spring-based applications and supports integration
with external systems via declarative adapters.
Those adapters provide a higher-level of abstraction
over Spring's support for remoting, messaging, and
scheduling. Spring Integration's primary goal is to
provide a simple model for building enterprise
integration solutions while maintaining the separation
of concerns that is essential for producing maintainable,
testable code.

%package javadoc
Summary:       Javadoc for %{name}

%description javadoc
This package contains javadoc for %{name}.

%prep
%setup -q -n %{oname}-%{namedversion} -a1
find . -name "*.bat" -delete
find . -name "*.class" -delete
find . -name "*.jar" -delete
%patch0 -p1
%patch1 -p1
%pom_add_dep org.igniterealtime.smack:smack-core:4.1.4:test %{oname}-ws
%pom_change_dep :smack :smack-extensions:4.1.4 %{oname}-xmpp
%pom_change_dep :smackx :smack-resolver-javax:4.1.4 %{oname}-xmpp
%pom_add_dep org.igniterealtime.smack:smack-tcp:4.1.4 %{oname}-xmpp

# This is a dummy POM added just to ease building in the RPM platforms
cat > pom.xml << EOF
<?xml version="1.0" encoding="UTF-8"?>
<project
  xmlns="http://maven.apache.org/POM/4.0.0"
  xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/maven-v4_0_0.xsd"
  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">

  <modelVersion>4.0.0</modelVersion>
  <groupId>org.springframework.integration</groupId>
  <artifactId>spring-integration</artifactId>
  <version>%{namedversion}</version>
  <packaging>pom</packaging>
  <name>Spring Integration</name>
  <modules>
    <module>spring-integration-amqp</module>
    <module>spring-integration-core</module>
    <module>spring-integration-event</module>
    <!-- module>spring-integration-feed</module NOT available build deps net.java.dev.rome:rome,rome-fetcher:1.0.0 -->
    <module>spring-integration-file</module>
    <module>spring-integration-ftp</module>
    <!-- module>spring-integration-gemfire</module NON FREE deps -->
    <module>spring-integration-groovy</module>
    <!-- module>spring-integration-http</module NOT available build deps net.java.dev.rome:rome,rome-fetcher:1.0.0 -->
    <module>spring-integration-ip</module>
    <module>spring-integration-jdbc</module>
    <module>spring-integration-jms</module>
    <module>spring-integration-jmx</module>
    <module>spring-integration-jpa</module>
    <module>spring-integration-mail</module>
    <module>spring-integration-mongodb</module>
    <module>spring-integration-redis</module>
    <module>spring-integration-rmi</module>
    <module>spring-integration-scripting</module>
    <module>spring-integration-security</module>
    <module>spring-integration-sftp</module>
    <module>spring-integration-stream</module>
    <module>spring-integration-syslog</module>
    <module>spring-integration-test</module>
    <module>spring-integration-twitter</module>
    <module>spring-integration-ws</module>
    <module>spring-integration-xml</module>
    <module>spring-integration-xmpp</module>
  </modules>
</project>
EOF

# Use jvm apis
%pom_remove_dep javax.activation:activation %{oname}-ftp
%pom_remove_dep javax.activation:activation %{oname}-mail
%pom_remove_dep javax.activation:activation %{oname}-sftp
%pom_remove_dep javax.activation:activation %{oname}-twitter
%pom_remove_dep javax.activation:activation %{oname}-ws
%pom_remove_dep javax.activation:activation %{oname}-xml
%pom_remove_dep javax.activation:activation %{oname}-xmpp

# Add OSGi support
for p in amqp \
 core \
 event \
 feed \
 file \
 ftp \
 gemfire \
 groovy \
 http \
 ip \
 jdbc \
 jms \
 jmx \
 jpa \
 mail \
 mongodb \
 redis \
 rmi \
 scripting \
 security \
 sftp \
 stream \
 syslog \
 test \
 twitter \
 ws \
 xml \
 xmpp; do
%pom_xpath_inject "pom:project" "<packaging>bundle</packaging>" %{oname}-${p}
%pom_add_plugin org.apache.felix:maven-bundle-plugin:2.5.4 %{oname}-${p} "
<extensions>true</extensions>
<configuration>
  <instructions>
    <Bundle-SymbolicName>\${project.groupId}.${p}</Bundle-SymbolicName>
    <Bundle-Name>\${project.name}</Bundle-Name>
    <Bundle-Version>\${project.version}</Bundle-Version>
  </instructions>
</configuration>
<executions>
  <execution>
    <id>bundle-manifest</id>
    <phase>process-classes</phase>
    <goals>
      <goal>manifest</goal>
    </goals>
  </execution>
</executions>"
done

# fix non ASCII chars
for s in %{oname}-core/src/main/java/org/springframework/integration/aggregator/AbstractCorrelatingMessageHandler.java \
 %{oname}-core/src/main/java/org/springframework/integration/aggregator/SequenceSizeReleaseStrategy.java;do
  native2ascii -encoding UTF8 ${s} ${s}
done

# Add Test deps
%pom_add_dep junit:junit:4.11:test %{oname}-core
%pom_add_dep org.easymock:easymock:3.3.1:test %{oname}-core
%pom_add_dep org.hamcrest:hamcrest-all:1.3:test %{oname}-core
%pom_add_dep org.mockito:mockito-core:1.9.5:test %{oname}-core
%pom_add_dep org.springframework:spring-test:3.2.11.RELEASE:test  %{oname}-core
%pom_add_dep org.springframework:spring-web:3.2.11.RELEASE:test  %{oname}-core
%pom_add_dep org.aspectj:aspectjweaver:1.8.4:test %{oname}-core
%pom_add_dep org.springframework:spring-web:3.2.11.RELEASE:test %{oname}-amqp
%pom_add_dep org.springframework:spring-web:3.2.11.RELEASE:test %{oname}-groovy
%pom_add_dep com.h2database:h2:test %{oname}-jdbc
%pom_add_dep log4j:log4j:1.2.17:test %{oname}-jdbc
%pom_add_dep org.powermock:powermock-module-junit4:1.5:test %{oname}-jdbc
%pom_add_dep org.powermock:powermock-api-mockito:1.5:test %{oname}-jdbc
%pom_add_dep log4j:log4j:1.2.17:test %{oname}-jms
%pom_add_dep org.apache.activemq:activemq-core:5.6.0:test %{oname}-jms
%pom_add_dep org.springframework:spring-oxm:3.2.11.RELEASE:test %{oname}-jms
%pom_add_dep org.aspectj:aspectjweaver:1.8.4:test %{oname}-jmx
%pom_add_dep org.apache.openjpa:openjpa-jdbc:2.2.0:test %{oname}-jpa
%pom_add_dep com.fasterxml.jackson.core:jackson-databind:2.5.0:test %{oname}-redis
%pom_add_dep org.python:jython-standalone:2.5.2:test %{oname}-scripting
%pom_add_dep org.apache.sshd:sshd-core:0.10.0:test %{oname}-sftp
%pom_add_dep org.springframework.ws:spring-ws-support:2.1.1.RELEASE:test %{oname}-ws
%pom_add_dep org.apache.geronimo.specs:geronimo-jms_1.1_spec:1.1.1:test %{oname}-ws
%pom_add_dep xmlunit:xmlunit:1.0:test %{oname}-xml

# Fix test deps
%pom_add_plugin "org.apache.maven.plugins:maven-jar-plugin:2.6" %{oname}-redis "
<executions>
  <execution>
    <goals>
      <goal>test-jar</goal>
    </goals>
  </execution>
</executions>"

%pom_add_dep org.springframework.integration:spring-integration-redis:'${project.version}':test %{oname}-twitter "<type>test-jar</type>"
%pom_add_dep org.springframework.integration:spring-integration-redis:'${project.version}':test %{oname}-twitter
%pom_add_dep com.lambdaworks:lettuce:2.3.3:test %{oname}-twitter

for p in amqp \
 event \
 feed \
 file \
 ftp \
 gemfire \
 groovy \
 http \
 ip \
 jdbc \
 jms \
 jmx \
 jpa \
 mail \
 mongodb \
 redis \
 rmi \
 scripting \
 security \
 sftp \
 stream \
 syslog \
 twitter \
 ws \
 xml \
 xmpp; do
 
%pom_add_dep org.springframework.integration:spring-integration-test:'${project.version}':test %{oname}-${p}
%pom_add_dep junit:junit:4.11:test %{oname}-${p}

# clone source directory structure
find %{oname}-${p}/src/main/java/ -type d | while read dirname ; do
  newdirname=`echo $dirname | sed "s:%{oname}-${p}/src/main/java:%{oname}-${p}/src/main/resources:g"`
  mkdir -p $newdirname
done

# copy everything except *.java sources
find %{oname}-${p}/src/main/java/ -type f | grep -v "\.java" | while read cpfrom ; do
  cpto=`echo $cpfrom | sed "s:%{oname}-${p}/src/main/java:%{oname}-${p}/src/main/resources:g"`
  cp $cpfrom $cpto
done

# Copy test resources in default maven location
find %{oname}-${p}/src/test/java/ -type d | while read dirname ; do
  newdirname=`echo $dirname | sed "s:%{oname}-${p}/src/test/java:%{oname}-${p}/src/test/resources:g"`
  mkdir -p $newdirname
done

find %{oname}-${p}/src/test/java/ -type f | grep -v "\.java" | while read cpfrom ; do
  cpto=`echo $cpfrom | sed "s:%{oname}-${p}/src/test/java:%{oname}-${p}/src/test/resources:g"`
  cp $cpfrom $cpto
done

done

# [55,8] org.springframework.integration.amqp.StubRabbitConnectionFactory is not abstract and does not override abstract method clearConnectionListeners() in org.springframework.amqp.rabbit.connection.ConnectionFactory
# [91,24] org.springframework.integration.amqp.StubRabbitConnectionFactory.StubChannel is not abstract and does not override abstract method basicConsume(java.lang.String,boolean,java.util.Map<java.lang.String,java.lang.Object>,com.rabbitmq.client.Consumer) in com.rabbitmq.client.Channel
rm -r %{oname}-amqp/src/test/java/org/springframework/integration/amqp/StubRabbitConnectionFactory.java
# Use org.apache.ftpserver:ftpserver-core:1.0.6 https://bugzilla.redhat.com/show_bug.cgi?id=855843
rm -r %{oname}-ftp/src/test/java/org/springframework/integration/ftp/TesFtpServer.java \
 %{oname}-ftp/src/test/java/org/springframework/integration/ftp/outbound/FtpServerOutboundTests.java
# package org.easymock.classextension does not exist
rm -r %{oname}-mail/src/test/java/org/springframework/integration/mail/config/MailToStringTransformerParserTests.java \
 %{oname}-mail/src/test/java/org/springframework/integration/mail/MailReceivingMessageSourceTests.java

# Convert from dos to unix line ending
for file in src/dist/*.txt; do
 sed -i.orig 's|\r||g' $file
 touch -r $file.orig $file
 rm $file.orig
done

%mvn_package :%{oname} __noinstall

%build

%mvn_build -- -Dproject.build.sourceEncoding=UTF-8

%install
%mvn_install

%files -f .mfiles
%doc CONTRIBUTING.md README.md src/dist/changelog.txt src/dist/readme.txt
%license src/dist/license.txt src/dist/notice.txt

%files javadoc -f .mfiles-javadoc
%license src/dist/license.txt src/dist/notice.txt

%changelog
* Fri Feb 05 2016 Fedora Release Engineering <releng@fedoraproject.org> - 3.0.7-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Sat Jan 30 2016 gil cattaneo <puntogil@libero.it> 3.0.7-1
- add smack 4.1.x support

* Sun Sep 27 2015 gil cattaneo <puntogil@libero.it> 3.0.7-1
- initial rpm
